with(LinearAlgebra);

A:= Matrix(6,4);

Ec    := (u^2 + v^2)/2;
c2    := (u^2 + v^2)/ M^2;
H     := Ec + c2/(gam-1);
#H := ((gam-1)*(1+t^2)*Ec + (u*t-v)^2) / ((gam-1)*(1+t^2)); 
tgphi := v/u;
tgbeta := 1 /sqrt(M^2-1);
t     := (tgphi + tgbeta)/(1-tgphi*tgbeta);
dy:=(tgphi + tgbeta);
dx := (1-tgphi*tgbeta);
kappa := u*t - v ;
gam1  := gam -1 ;
E := c2/ (gam*(gam-1)) + Ec ;
p := (gam-1)*rho*(E-Ec);



# first line :

A[1,1] := dx^3*kappa*gam1*(u+t*v)*Ec; 
A[1,2] :=  dx^3*kappa*(kappa*v*gam + 2*Ec*gam1);
A[1,3] := dx^3*kappa*(-gam1*v*(t*v+u)+ kappa*u);
A[1,4] :=  -dx^3*gam1*kappa*(t*v + u);

# second line :

A[2,1] :=  Ec*dx^3*gam1*kappa*( H*gam1 - Ec*(gam+1));
A[2,2] :=dx^3*kappa*(Ec*gam1*(t*kappa -gam*u) +t^2*u^3  + 2*u*v^2 - 3*t*u^2*v + H*gam1*((gam-2)*u-t*kappa) );
A[2,3] :=dx^3*kappa*(-u^2*kappa + gam1*((gam+1)*v-t*u)*Ec + H*gam1*(t*u - gam1*v));
A[2,4] :=(dx^3*gam1*kappa*( -H*gam1+Ec*(gam+1)));

# third line :

A[3,1] :=Ec*dx^3*gam1*kappa*t*(-H*gam1 + Ec*(gam+1));
A[3,2] :=dx^3*kappa*( gam1*((gam+1)*t*u-v)*Ec + v^2*kappa + H*gam1*(v - gam1*t*u) );
A[3,3] :=dx^3*kappa*t*(H*gam1*(gam1*v-t*u) - 2*gam1*v*Ec - gam1^2*v*Ec + u^2*kappa + gam1*t*u*Ec);
A[3,4] :=  (dx^3*gam1*kappa*t*(H*gam1 - (gam+1)*Ec));

# fourth line :

A[4,1] :=-Ec* dx^3 *gam1 * kappa * (u+t*v)*(gam1*Ec+H*(2-gam));
A[4,2] := -dx^3 * kappa*(2*Ec*gam1 + gam*kappa*v)*(gam1*Ec + H*(2-gam));
A[4,3] :=dx^3*kappa*(-u*kappa + gam1*t*v^2 + gam1*u*v)*(gam1*Ec +H*(2-gam));
A[4,4] := dx^3 *gam1 * kappa * (u+t*v)*(gam1*Ec+H*(2-gam));


Rank_of_Matrix_A = Rank(A);







