with(LinearAlgebra);

A:= Matrix(4,4);

Ec    := (u^2 + v^2)/2;
c2    := (u^2 + v^2)/ M^2;
H     := Ec + c2/(gam-1);
t     := v/u;
kappa := 0 ;
gam1  := gam -1 ;
dy := v;
dx := u;
E := c2/ (gam*(gam-1)) + Ec ;



# first line :

A[1,1] :=  -dx ^3*(-H*gam1*v - H*gam1*t^2*v + gam1*Ec*(u*t+v)+ gam1*t^2*2*Ec*v);
A[1,2] :=  -dx^2 * dy * (2*Ec * (gam-1));
A[1,3] :=  dx^2*dy*(-2*Ec*t + gam*v*(t*v+u));
A[1,4] :=  dx^2 * dy *gam1 *(t*v+u);

# second line :

A[2,1] :=  Ec*dx^2*dy*gam1*( -H*gam1 + (gam+1)*Ec);
A[2,2] :=dx^3 *  (gam1^2*t*u*Ec  + H*gam1*v -H*gam1^2*t*u+gam1*t*u*Ec);
A[2,3] :=dx^2*dy*(H*gam1^2*v - gam1*v*Ec - gam1^2*v*Ec - H*gam1*t*u);
A[2,4] :=dx^2*dy*gam1*( H*gam1 - (gam+1)*Ec);

# third line :

A[3,1] :=Ec*dx^2*dy*gam1*t*(H*gam1 - (gam+1)*Ec);
A[3,2] :=dx^2*dy*( - gam1^2*t*u *Ec - H*gam1*v + H*gam1^2*t*u -gam1*t*u*Ec );
A[3,3] :=dx^3*(-v^3 + 3*t*u*v^2 - 2*t^2*u^2*v+gam1^2*t^2*v*Ec +H*gam1*t^2*v -H*gam1^2*t^2*v + gam1*t^2*v*Ec);
A[3,4] := dx^2*dy*gam1*t*(-H*gam1 + (gam+1)*Ec);

# fourth line :

A[4,1] := Ec*dx^2*dy*gam1*(u+t*v)*( H*(2-gam)  +gam1*Ec);
A[4,2] :=dx^2*dy*(gam1*u^2  + gam1*t*u*v)*(gam1*Ec + H*(2-gam) );
A[4,3] :=dx^2*dy*((-gam1*t*v^2-gam1*u*v)*(gam1*Ec+H*(2-gam)));
A[4,4] :=dx^3*( - gam1*v*Ec - gam1^2*t*u*Ec - gam1*t^2*v*Ec - gam1^2*t^2*v*Ec + H*gam1^2*t*u + H*gam1^2*t^2*v  );




E1212 := Determinant(SubMatrix(A,[1,2] , [1,2]));
E1223 := Determinant(SubMatrix(A,[1,2] , [2,3]));
E1234 := Determinant(SubMatrix(A,[1,2] , [3,4]));

E1312 := Determinant(SubMatrix(A,[1,3] , [1,2]));
E1323 := Determinant(SubMatrix(A,[1,3] , [2,3]));
E1334 := Determinant(SubMatrix(A,[1,3] , [3,4]));

E1412 := Determinant(SubMatrix(A,[1,4] , [1,2]));
E1423 := Determinant(SubMatrix(A,[1,4] , [2,3]));
E1434 := Determinant(SubMatrix(A,[1,4] , [3,4]));


Rank_of_Matrix_A = Rank(A);
